		/////////////////////////////////////////////////////////////////////
		// user.js
		// - Javascript functions related to user and server templates.
		/////////////////////////////////////////////////////////////////////
		
		var render_user_box = function()
		{
		    if (!%enable_user_avatar%)
		        show_element("user_avatar_id", false);
		        
		    if (!%is_user_blocked%)
		        show_element("blocked_user_link", false);
		    
			if (!%user_has_clan_nickname% || ("%js:user_display_name%" == "%js:clan_member_nickname%"))
				show_element("user_clan_nickname_row", false);
			
			if (!%user_hasnickname% || ("%js:user_display_name%" == "%js:user_nickname%"))
				show_element("user_nickname_row", false);
				
			if ("%js:user_display_name%" == "%js:username%")
				show_element("username_row", false);

			if (!%voice_hasip%)
				show_element("voice_chat_row", false);
				
			render_status();
		}

		var render_status = function()
		{
			var element = document.getElementById('status_id');
			if (element)
			{
				element.innerHTML = linkify("%js:status%");
			}
		}
		
		var render_clans_box = function()
		{
			var user_clan_info = [ %user_clan_info% ];
			if (!user_clan_info.length)
				show_element("clans_box", false);
		}

        var render_user_ss = function()
        {
            // Hide the box until we get a valid response back that this user has remote screenshots.
            show_element("user_ss_box", false);
            
            // Check client setting to see if we are requesting user screenshots
            request_ss_count();
        }

        
        function request_ss_count()
        {
            var screenshot_array = [ %user_ss_data% ];
            if (!screenshot_array.length)
                return;
            
            // Show screenshots box
            show_element("user_ss_box", true);

            // Insert up to 2 of this users latest screenshot thumbs
			var user_ss_div = document.getElementById("user_ss_id");
			if (!user_ss_div)
			    return;

            var strInnerHTML = "";
            strInnerHTML += "<table border='0' >";
            strInnerHTML += "<tr>";
            for (var i = 0; (i < screenshot_array.length) && (i < 2) && (screenshot_array[i].filename.length); ++i)
            {
                var strThumbnailURL = "http://%js:screenshot_host%/screenshot/thumb/" + screenshot_array[i].filename;
                var strThumbnailHREF = "%js:www_url%/screenshots/%js:username%/ss_file-" + screenshot_array[i].filename;
                var created = new Date(screenshot_array[i].timestamp * 1000);
                var strAltText = created.toLocaleString() + "\n" + screenshot_array[i].gamename;
                if (screenshot_array[i].description.length)
                    strAltText += "\n" + screenshot_array[i].description;
                strInnerHTML += "<td>";
                strInnerHTML += "<a href='" + strThumbnailHREF + "' target='_blank'><img src='" + strThumbnailURL + "' alt='" + strAltText + "' width='108' height='81' style='cursor:pointer;border:none;' /></a>";
                strInnerHTML += "</td>";
            }
            strInnerHTML += "</tr>";
            strInnerHTML += "<tr><td colspan='2' align='center'><a href='%js:www_url%/screenshots/%js:username%' target='_blank'>%js:text_see_all_ss%</a></td></tr>";
            strInnerHTML += "</table>";
            
            user_ss_div.innerHTML = strInnerHTML;
            
			// Any time new elements are dynamically added/removed, we need to inform the client app.
			// Fire off an event which will tell the client to rebuild the html event sinks.
            RebuildEventSinks();
        }
        
		// ATTEMPT TO INCLUDE OVERRIDE
		%include user.js%
