%include scripts/AjaxRequest.js%

// custom overrides for world of warcraft

render_game_stats_hash = function()
{
	var game_stats_hash = { %game_stats_hash% };

	if (%has_game_stats_hash% && game_stats_hash['realmName'])
	{
		var tbody = document.getElementById("server_tbody_id");
		if (tbody)
		{
			var tbody_rows = tbody.rows;
			var nInsertionRow = -1; // appends new rows
			if (tbody_rows)
			{
				// want to insert new rows prior to the rcon row
				for (var rowit = 0; rowit < tbody_rows.length; ++rowit)
				{
					var tr_element = tbody_rows.item(rowit);
					if (tr_element && tr_element.id == "rcon_row")
					{
						nInsertionRow = rowit;
						break;
					}
				}
			}

			//alert("insert at: " + nInsertionRow);
			var new_tr = tbody.insertRow(nInsertionRow);
			var new_th = document.createElement("TH");
			new_th.className = "first_char_uppercase";
			new_th.innerText = "Realm";
			var new_td = document.createElement("TD");
			new_td.innerText = game_stats_hash['realmName'];
			new_tr.appendChild(new_th);
			new_tr.appendChild(new_td);
		}
	}
}

function getAbsoluteTop(obj)
{
	if (!obj)
		return 0;
	return obj.offsetTop + getAbsoluteTop(obj.offsetParent);
}

function getAbsoluteLeft(obj)
{
	if (!obj)
		return 0;
	return obj.offsetLeft + getAbsoluteLeft(obj.offsetParent);
}

function setupSlots()
{
	AjaxRequest.get({
		url:'%scripting_host%/client/games_stats/wow-item.xsl',
		onSuccess:function (req)
			{
				xsl = req.responseXML;
			  	if (document.getElementById('debug'))
				{
					document.getElementById('debug').value = "===\nXSL\n===\n";
					document.getElementById('debug').value += req.url + "\n";
			    		document.getElementById('debug').value += req.responseText;
				}
			},
		onError:function (req)
			{
				//alert("error getting xsl");
			}
	  });
	AjaxRequest.get({
		url:'%scripting_host%/client/games_stats/wow-header.xsl',
		onSuccess:function (req)
			{
				header = req.responseXML;
			  	if (document.getElementById('debugxsl'))
				{
					document.getElementById('debug').value = "===\nHeader XSL\n===\n";
					document.getElementById('debug').value += req.url + "\n";
			    		document.getElementById('debug').value += req.responseText;
				}
			},
		onError:function (req)
			{
				//alert("error getting xsl");
			}
	  });
	AjaxRequest.get({
		// url:'http://armory.worldofwarcraft.com/character-sheet.xml',
		url:'%scripting_host%/client/games_stats/wow-info.php',
		parameters:{username:'%username%'},
		onSuccess:function (req)
			{
				var chars = req.responseXML.getElementsByTagName('characters');
			  	if (document.getElementById('debugxsl'))
				{
					document.getElementById('debug').value = "===\nWoW Info XSL\n===\n";
					document.getElementById('debug').value += req.url + "\n";
			    		document.getElementById('debug').value += req.responseText;
				}
				var char_select = document.getElementById('char_selection');
				if (char_select && chars.length > 0)
				{
					var char = chars[0].firstChild;
					if (char)
					{
						var select_c = "<select id='charName' onchange='doWow()'>";
						while (char)
						{
							select_c += "<option value='";
							select_c += char.getAttribute('name').replace("'", '&#039;') + "-" + char.getAttribute('realm').replace("'", '&#039;') + "-" + char.getAttribute('region').replace("'", '&#039;');
							select_c += "'>" + char.getAttribute('name').replace("'", '&#039;') + "/" + char.getAttribute('realm').replace("'", '&#039;') + "</option>";
							
							char = char.nextSibling;
						}
						select_c += "</select>";
						char_select.innerHTML = "Character: " + select_c;

						var wow_box = document.getElementById('wow_box');
						if (wow_box)
						{
							wow_box.style.display = '';
							var wow = document.getElementById('wow_items');
							if (wow)
							{
								var t = getAbsoluteTop(wow);
								var l = getAbsoluteLeft(wow);
								for (var i = 0; i < 19; i++)
								{
									var div = document.getElementById('slot' + i);
									if (div)
									{
										if (i < 8)
										{
											div.style.top = (t + i*56) + "px";
											div.style.left = l + "px";
										}
										else if (i < 15)
										{
											div.style.top = (t + (i-8)*56) + "px";
											div.style.left = (l + 60 + 180) + "px";
										}
										else
										{
											div.style.top = (t + 7*56) + "px";
											div.style.left = (l + 60*(i-14)) + "px";
										}
										switch(i)
										{
											case 3:
												div.style.top = (t + 5*56) + "px";
												break;
											case 5:
												div.style.top = (t + 1*56) + "px";
												div.style.left = (l + 60 + 180) + "px";
												break;
											case 6:
												div.style.top = (t + 2*56) + "px";
												div.style.left = (l + 60 + 180) + "px";
												break;
											case 7:
												div.style.top = (t + 3*56) + "px";
												div.style.left = (l + 60 + 180) + "px";
												break;
											case 8:
												div.style.top = (t + 7*56) + "px";
												div.style.left = (l) + "px";
												break;
											case 9:
												div.style.top = (t + 0*56) + "px";
												div.style.left = (l + 60 + 180) + "px";
												break;
											case 10:
											case 11:
											case 12:
											case 13:
												div.style.top = (t + (i-6)*56) + "px";
												break;
											case 14:
												div.style.top = (t + 3*56) + "px";
												div.style.left = (l) + "px";
												break;
											case 18:
												div.style.top = (t + 6*56) + "px";
												div.style.left = (l) + "px";
												break;
										}
									}
								}
						
								var wow_info = document.getElementById('wow_info');
								if (wow_info)
								{
									wow_info.style.top = (t + 5) + "px";
									wow_info.style.left = (l + 65) + "px";
								}
							}
						}

						doWow();
						return;
					}
				}
			},
		onError:function (req)
			{
				//alert("error getting character list");
			}
	  });
}

var xsl = null;
var header = null;
var strings = null;
var lang = "%language%";
var attempts = new Object();

function mouseOn(obj)
{
	if (!obj)
	{
		return;
	}

	var charName = "";
	var realmName = "";
	var region = "";

	var slct = document.getElementById('charName');
	if (slct)
	{
		var blob = slct.options[slct.selectedIndex].value;
		var idx = blob.indexOf('-');
		if (idx != -1)
		{
			charName = blob.substr(0, idx);
			idx++;
			var idx2 = blob.indexOf('-', idx);
			if (idx2 != -1)
			{
			  realmName = blob.substr(idx, idx2-idx);
			  region = blob.substr(idx2+1);
			}
		}
	}

	obj.style.backgroundPosition="-66px 0px";
	var wow_info = document.getElementById('wow_info');
	if (obj.getAttribute('itemid'))
	{
		AjaxRequest.get({
		        url:'%scripting_host%/client/games_stats/wow.php',
			// url:'http://armory.worldofwarcraft.com/item-tooltip.xml',
			parameters:{itemid:obj.getAttribute('itemid'), realm:realmName, char:charName, region:region, mode:'item'},
			onSuccess:function (req)
				{
				  	if (document.getElementById('debug'))
					{
						document.getElementById('debug').value = "===\nItem\n===\n";
						document.getElementById('debug').value += req.url;
				    		document.getElementById('debug').value += req.responseText;
					}

					var xfire = req.responseXML.getElementsByTagName('xfire');
					if (xfire.length != 0)
					{
						if(xfire[0].getAttribute('error'))
						{
							//alert("Error fetching XML: '" + xfire[0].getAttribute('str') + "'\ncode: " + xfire[0].getAttribute('error'));
							return;
						}
						//if (xfire[0].getAttribute('retry'))
						//{
						//	setTimeout("mouseOn(document.getElementById(" + obj.getAttribute('id') + "))", xfire[0].getAttribute('retry'));
						//}
					}

					var html = "";
					var page = req.responseXML.getElementsByTagName('page');
					if (page.length > 0)
					{
						if (lang == "de")
						{
							page[0].setAttribute('lang', 'de_de');
						}
						else if (lang == "es")
						{
							page[0].setAttribute('lang', 'es_es');
						}
						else if (lang == "fr")
						{
							page[0].setAttribute('lang', 'fr_fr');
						}
						if (xsl)
							html = req.responseXML.transformNode(xsl);
					}

					wow_info.innerHTML = html;
				},
			onError:function (req)
				{
					//alert('error getting item xml');
				}
			});
	}
	else
	{
		showCharInfo();
	}
}


function mouseOff(obj)
{
	obj.style.backgroundPosition="";
}

function showCharInfo()
{
	var wow_info = document.getElementById('wow_info');
	var char_tab = document.getElementById('char_tab');
	if (wow_info && char_tab)
	{
		wow_info.innerHTML = char_tab.innerHTML;
	}
}

function doWow()
{
	var charName = "";
	var realmName = "";
	var region = "";

	var slct = document.getElementById('charName');
	if (slct)
	{
		var blob = slct.options[slct.selectedIndex].value;
		var idx = blob.indexOf('-');
		if (idx != -1)
		{
			charName = blob.substr(0, idx);
			idx++;
			var idx2 = blob.indexOf('-', idx);
			if (idx2 != -1)
			{
			  realmName = blob.substr(idx, idx2-idx);
			  region = blob.substr(idx2+1);
			}
		}
	}

	if (charName != "" && realmName != "" && region != "")
	{
		if (attempts.last == (charName+'/'+realmName+'/'+region))
		{
			if (attempts.times > 3)
				return;	// too many attempts
			else
				attempts.times++;
		}
		else
		{
			attempts.last = charName+'/'+realmName+'/'+region;
			attempts.times = 0;
		}

		AjaxRequest.get({
		        // url:'http://armory.worldofwarcraft.com/character-sheet.xml',
			url:'%scripting_host%/client/games_stats/wow.php',
			parameters:{realm:realmName, char:charName, region:region, mode:'character'},
			onSuccess:function (req)
			          {
				  	if (document.getElementById('debug'))
					{
						document.getElementById('debug').value = "===\nCharacter\n===\n";
						document.getElementById('debug').value += req.url + "\n";
				    		document.getElementById('debug').value += req.responseText;
					}

				  	var dom = req.responseXML;
					if (!dom.selectSingleNode('/xfire'))
						return;

					var regionBase = dom.selectSingleNode('/xfire').getAttribute('regionBase');
					var charUrl = dom.selectSingleNode('/xfire/page/characterInfo/character/@charUrl');
					if (charUrl)
						charUrl = charUrl.text;
					if (!strings)
					{
						var wowLang = dom.selectSingleNode('/xfire/page').getAttribute('lang');
	
						AjaxRequest.get({
							url:regionBase + '/strings/' + wowLang + '/strings.xml',
							async:false,
							onSuccess:function (req)
							{
								strings = req.responseXML;
							},
							onError:function (req)
							{
								//alert("error getting strings");
							}
						});
					}

					var xfire = req.responseXML.getElementsByTagName('xfire');
					if (xfire.length != 0)
					{
						if(xfire[0].getAttribute('error'))
						{
							//alert("Error fetching XML: '" + xfire[0].getAttribute('str') + "'\ncode: " + xfire[0].getAttribute('error'));
							return;
						}

						if (xfire[0].getAttribute('retry'))
						{
							setTimeout("doWow()", xfire[0].getAttribute('retry'));
						}
					}
	
					var wow = document.getElementById('wow_items');
	
					var character = dom.getElementsByTagName('character');
					if (character.length != 0)
					{
						var char_box = document.getElementById('char_box');
						if (char_box)
						{
							var level = character[0].getAttribute('level');
							var genderid = character[0].getAttribute('genderId');
							var raceid = character[0].getAttribute('raceId');
							var classid = character[0].getAttribute('classId');
							var char_img = document.getElementById('char_img');
							if (char_img)
							{
								var portrait_url = regionBase;
								if (level < 60)
								{
									portrait_url += "/images/portraits/wow-default/";
								}
								else if (level < 70)
								{
									portrait_url += "/images/portraits/wow/";
								}
								else
								{
									portrait_url += "/images/portraits/wow-70/";
								}
								portrait_url += genderid + "-" + raceid + "-" + classid + ".gif";
								char_img.src = portrait_url;
							}
							
							var char_name_anchor = document.getElementById('char_name_anchor');
							if (char_name_anchor)
							{
								char_name_anchor.innerHTML = charName;
							}

							if (character[0].getAttribute("guildName"))
							{
								var guild_name = document.getElementById('guild_name');
								if (guild_name)
								{
									guild_name.innerHTML = "&lt;" + character[0].getAttribute("guildName") + "&gt;";
								}
							}

							var char_info = document.getElementById('char_info');
							if (char_info)
							{
								var level_str = strings.selectSingleNode("/strs/character/str[@id='character-level']");
								if (level_str)
									level_str = level_str.text;
								else
									level_str = "Level";
								
								var race_str = strings.selectSingleNode("/strs/races/str[@id='armory.races.race." + raceid + "." + genderid + "']");
								if (race_str)
									race_str = race_str.text;
								else
								  race_str = character[0].getAttribute("race");

								var class_str = strings.selectSingleNode("/strs/classes/str[@id='armory.classes.class." + classid + "." + genderid + "']");
								if (class_str)
									class_str = class_str.text;
								else
									class_str = character[0].getAttribute("class");

								char_info.innerHTML = level_str + " " + level + " " + race_str + " " + class_str;
							}
						}
					}
					else
					{
						var char_box = document.getElementById('char_box');
						if (char_box)
						{
							char_box.outerHTML = "<div id='char_box'></div>";
						}
					}
	
					var items = dom.getElementsByTagName('items');
					var not_found = document.getElementById('char_not_found');
					if (items.length == 0)
					{
						if (not_found)
						{
							not_found.style.display = "";
						}
						return;
					}
						
					if (not_found)
					{
						not_found.style.display = "none";
					}
	
					for (var i = 0; i < 19; i++)
					{
						var frame = document.getElementById('frame'+i);
						if (frame)
						{
							frame.removeAttribute('itemid');
						}
						var div = document.getElementById('slot'+i);
						if (div)
						{
							div.style.backgroundImage = '';
						}
					}
					var wow_info = document.getElementById('wow_info');
					if (wow_info)
					{
						wow_info.innerHTML = '';
						var char_info = document.getElementById('char_tab');
						fillInString('talentStr', "/strs/characterSheet/str[@id='armory.character.talent-specialization']");
						fillInString('healthStr', "/strs/character/str[@id='character.health']");
						var char_tab = dom.selectSingleNode('/xfire/page/characterInfo/characterTab');
						if (char_tab)
						{
							var talentLink = document.getElementById('talentLink');
							if (talentLink)
							{
								talentLink.href=regionBase + '/character-talents.xml?' + charUrl;
							}

							var charClassId = dom.selectSingleNode("/xfire/page/characterInfo/character/@classId").text;
							var treeNameOne = 'armory.class' + charClassId + '.talents.tree.one';
							var treeNameTwo = 'armory.class' + charClassId + '.talents.tree.two';
							var treeNameThree = 'armory.class' + charClassId + '.talents.tree.three';

							var talentsTreeArray = new Array;
							talentsTreeArray[0] = [1, char_tab.selectSingleNode("talentSpec/@treeOne").text, strings.selectSingleNode("/strs/talents/str[@id='" + treeNameOne + "']").text];
							talentsTreeArray[1] = [2, char_tab.selectSingleNode("talentSpec/@treeTwo").text, strings.selectSingleNode("/strs/talents/str[@id='" + treeNameTwo + "']").text];
							talentsTreeArray[2] = [3, char_tab.selectSingleNode("talentSpec/@treeThree").text, strings.selectSingleNode("/strs/talents/str[@id='" + treeNameThree + "']").text];
							var talentSpecText = "";

							talentsTreeArray = talentsTreeArray.sort(sortArray);

							if (talentsTreeArray[0][1] == 0) {
							  highest = -1;
							} else {
							  highest = talentsTreeArray[0][0];
							  if ((3 * (talentsTreeArray[1][1] - talentsTreeArray[2][1])) >= (2 * (talentsTreeArray[0][1] - talentsTreeArray[2][1])))
							    highest = 0;
							}

							if (highest == 1 || highest == 2 || highest == 3)
							  talentSpecText = talentsTreeArray[0][2];
							else if (highest == 0)
							{
							  talentSpecText = strings.selectSingleNode("/strs/str[@id='armory.talents.hybrid']");
							  if (talentSpecText)
							    talentSpecText = talentSpecText.text;
							  else
								  talentSpecText = "Hybrid";
							}
							else
							{
							  talentSpecText = strings.selectSingleNode("/strs/str[@id='armory.talents.untalented']");
							  if (talentSpecText)
							    talentSpecText = talentSpecText.text;
							  else
								  talentSpecText = "Untalented";
							}

							document.getElementById('talentSpecStr').innerHTML = talentSpecText;

							if (highest > 0)
							  document.getElementById('talentSpecImage').src = regionBase + '/images/icons/class/' + charClassId + '/talents/' + highest + '.png';
							else if (highest == 0)
							  document.getElementById('talentSpecImage').src = regionBase + '/images/icons/class/talents/hybrid.png';
							else
							  document.getElementById('talentSpecImage').src = regionBase + '/images/icons/class/talents/untalented.png';

							fillInXPath('talentVals1', char_tab, "talentSpec/@treeOne");
							fillInXPath('talentVals2', char_tab, "talentSpec/@treeTwo");
							fillInXPath('talentVals3', char_tab, "talentSpec/@treeThree");
							var second_bar_type = char_tab.selectSingleNode('characterBars/secondBar/@type').text;
							if (second_bar_type == 'r')
							{
								fillInString('secondBarStr', "/strs/character/str[@id='character.rage']");
								document.getElementById('secondBar').style.backgroundImage = 'url(' + regionBase + '/images/bar-rage.gif)';
							}
							else if (second_bar_type == 'e')
							{
								fillInString('secondBarStr', "/strs/character/str[@id='character.energy']");
								document.getElementById('secondBar').style.backgroundImage = 'url(' + regionBase + '/images/bar-energy.gif)';
							}
							else
							{
								fillInString('secondBarStr', "/strs/character/str[@id='character.mana']");
								document.getElementById('secondBar').style.backgroundImage = 'url(' + regionBase + '/images/bar-mana.gif)';
							}
							document.getElementById('healthBar').style.backgroundImage = 'url(' + regionBase + '/images/bar-life.gif)';
							fillInXPath('healthBar', char_tab, "characterBars/health/@effective");
							fillInXPath('secondBar', char_tab, "characterBars/secondBar/@effective");
						}
						wow_info.innerHTML = char_info.innerHTML;
					}
					var item = items[0].firstChild;
					while (item)
					{
						if (item.getAttribute('icon'))
						{
							var div = document.getElementById('slot' + item.getAttribute('slot'));
							if (div)
							{
								div.style.backgroundImage = 'url(http://armory.worldofwarcraft.com/images/icons/51x51/' + item.getAttribute('icon') + '.jpg)';
								var frame = document.getElementById('frame'+item.getAttribute('slot'));
								frame.setAttribute('itemid', item.getAttribute('id'));
							}
						}
						else
						{
							//alert('no icon');
						}
						item = item.nextSibling;
					}
					RebuildEventSinks();
				  },
			onError:function (req)
			        {
					//alert("error for '" + req.url + "': " + req.statusText + "(" + req.status + ")");
				}
		});
	}
}

function fillInString(doc_id, node_id)
{
	fillInXPath(doc_id, strings, node_id);
}

function fillInXPath(doc_id, xml_dom, node_id)
{
	var elem = document.getElementById(doc_id);
	if (elem && xml_dom)
	{
		var xml_elem = xml_dom.selectSingleNode(node_id);
		if (xml_elem)
		{
			elem.innerHTML = xml_elem.text;
		}
	}
}

function sortArray(a,b)
{
	return b[1] - a[1];
}

render_game_stats_hash = function()
{
	var game_stats_hash = { %game_stats_hash% };

	if (%has_game_stats_hash% && game_stats_hash['realmName'])
	{
		var tbody = document.getElementById("server_tbody_id");
		if (tbody)
		{
			var tbody_rows = tbody.rows;
			var nInsertionRow = -1; // appends new rows
			if (tbody_rows)
			{
				// want to insert new rows prior to the rcon row
				for (var rowit = 0; rowit < tbody_rows.length; ++rowit)
				{
					var tr_element = tbody_rows.item(rowit);
					if (tr_element && tr_element.id == "rcon_row")
					{
						nInsertionRow = rowit;
						break;
					}
				}
			}

			//alert("insert at: " + nInsertionRow);
			var new_tr = tbody.insertRow(nInsertionRow);
			var new_th = document.createElement("TH");
			new_th.className = "first_char_uppercase";
			new_th.innerText = "Realm";
			var new_td = document.createElement("TD");
			new_td.innerText = game_stats_hash['realmName'];
			new_tr.appendChild(new_th);
			new_tr.appendChild(new_td);
		}
	}
}
